Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 98)
@@ -500,28 +561,227 @@
 !
 ! input:
+!   itime        numero du pas de temps
+!   iim, jjm     nbres de pts de grille
+!   dtime        pas de tempsde la physique
+!   klon         nombre total de points de grille
 !   nisurf       index de la surface a traiter (1 = sol continental)
+!   pctsrf       tableau des fractions de surface de chaque maille
+!   knon         nombre de points de la surface a traiter
+!   knindex      index des points de la surface a traiter
+!   rlon         longitudes
+!   rlat         latitudes
+!   debut        logical: 1er appel a la physique
+!   lafin        logical: dernier appel a la physique
 !   ocean        type d'ocean
+!   nexca        frequence de couplage
+!   swdown       flux solaire entrant a la surface
+!   lwdown       flux IR entrant a la surface
+!   precip_rain  precipitation liquide
+!   precip_snow  precipitation solide
+!   evap         evaporation
+!   tsurf        temperature de surface
+!   fder         derivee dF/dT
+!   albsol       albedo du sol (coherent avec swdown)
+!   taux         tension de vent en x
+!   tauy         tension de vent en y
+!   nexca        frequence de couplage
+!
 !
 ! output:
-!
+!   tsurf_new    temperature au sol
+!   alb_new      albedo
+!   pctsrf_new   nouvelle repartition des surfaces
+!   alb_ice      albedo de la glace
+!
+
+#include 'indicesol.h'
 
 ! Parametres d'entree
+  integer, intent(IN) :: itime
+  integer, intent(IN) :: iim, jjm
+  real, intent(IN) :: dtime
+  integer, intent(IN) :: klon
   integer, intent(IN) :: nisurf
+  integer, intent(IN) :: knon
+  real, dimension(klon,nbsrf), intent(IN) :: pctsrf
+  integer, dimension(knon), intent(in) :: knindex
+  logical, intent(IN) :: debut, lafin
+  real, dimension(klon), intent(IN) :: rlon, rlat
   character (len = 6)  :: ocean
+  real, dimension(knon), intent(IN) :: lwdown, swdown
+  real, dimension(knon), intent(IN) :: precip_rain, precip_snow
+  real, dimension(knon), intent(IN) :: tsurf, fder, albsol, taux, tauy
+  integer              :: nexca
+
+  real, dimension(knon), intent(INOUT) :: evap
 
 ! Parametres de sortie
+  real, dimension(knon), intent(OUT):: tsurf_new, alb_new, alb_ice
+  real, dimension(klon,nbsrf), intent(OUT) :: pctsrf_new
 
 ! Variables locales
-
-
+  integer                    :: j, error, sum_error, ig
+  integer                    :: npas
+  character (len = 20) :: modname = 'interfoce_cpl'
+  character (len = 80) :: abort_message
+  logical              :: check = .true.
+! variables pour moyenner les variables de couplage
+  real, allocatable, dimension(:),save :: cpl_sols, cpl_nsol, cpl_rain
+  real, allocatable, dimension(:),save :: cpl_snow, cpl_evap, cpl_tsol
+  real, allocatable, dimension(:),save :: cpl_fder, cpl_albe, cpl_taux
+  real, allocatable, dimension(:),save :: cpl_tauy, cpl_ruis
+! variables a passer au coupleur
+  real, dimension(iim, jjm+1) :: wri_sols, wri_nsol, wri_rain
+  real, dimension(iim, jjm+1) :: wri_snow, wri_evap, wri_tsol
+  real, dimension(iim, jjm+1) :: wri_fder, wri_albe, wri_taux
+  real, dimension(iim, jjm+1) :: wri_tauy, wri_ruis
+! variables relues par le coupleur
+  real, dimension(iim, jjm+1) :: read_sst, read_sic
+  real, dimension(iim, jjm+1) :: read_alb_sst, read_alb_sic
+! variable tampon
+  real, dimension(klon)       :: tamp
+  real, dimension(knon)       :: tamp_sic
+
+
+!
 ! Initialisation
+!
+  if (debut) then
+    sum_error = 0
+    allocate(cpl_sols(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_nsol(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_rain(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_snow(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_evap(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_tsol(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_fder(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_albe(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_taux(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_tauy(knon), stat = error)
+    sum_error = sum_error + error
+    allocate(cpl_ruis(knon), stat = error)
+    sum_error = sum_error + error
+    if (sum_error /= 0) then
+      abort_message='Pb allocation variables couplees'
+      call abort_gcm(modname,abort_message,1)
+    endif
+    cpl_sols = 0.
+    cpl_nsol = 0.
+    cpl_rain = 0.
+    cpl_snow = 0.
+    cpl_evap = 0.
+    cpl_tsol = 0.
+    cpl_fder = 0.
+    cpl_albe = 0.
+    cpl_taux = 0.
+    cpl_tauy = 0.
+    cpl_ruis = 0.
+!
+! initialisation couplage
+!
+    call inicma(npas, nexca, dtime)
+!
+! 1ere lecture champs ocean
+!
+    call fromcpl(itime,(jjm+1)*iim,                                          &
+     &        read_sst, read_sic, read_alb_sst, read_alb_sic)
+    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_sic, tamp_sic , klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_alb_sst, alb_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_alb_sic, alb_ice, klon, knon,iim,jjm, knindex)
+!
+! transformer tamp_sic en pctsrf_new
+!
+    do ig = 1, klon
+      IF (pctsrf(ig,is_oce) > epsfra .OR.            &
+     &             pctsrf(ig,is_sic) > epsfra) THEN
+            pctsrf_new(ig,is_oce) = pctsrf(ig,is_oce)    &
+     &                        - (tamp_sic(ig)-pctsrf(ig,is_sic))
+            pctsrf_new(ig,is_sic) = tamp_sic(ig)
+      endif
+    enddo
+
+  endif ! fin if (debut)
+
 ! fichier restart et fichiers histoires
 
 ! calcul des fluxs a passer
 
+  cpl_sols = cpl_sols + swdown      / FLOAT(nexca)
+  cpl_nsol = cpl_nsol + lwdown      / FLOAT(nexca)
+  cpl_rain = cpl_rain + precip_rain / FLOAT(nexca)
+  cpl_snow = cpl_snow + precip_snow / FLOAT(nexca)
+  cpl_evap = cpl_evap + evap        / FLOAT(nexca)
+  cpl_tsol = cpl_tsol + tsurf       / FLOAT(nexca)
+  cpl_fder = cpl_fder + fder        / FLOAT(nexca)
+  cpl_albe = cpl_albe + albsol      / FLOAT(nexca)
+  cpl_taux = cpl_taux + taux        / FLOAT(nexca)
+  cpl_tauy = cpl_tauy + tauy        / FLOAT(nexca)
+  cpl_ruis = cpl_ruis + run_off     / FLOAT(nexca)/dtime
+
+  if (mod(itime, nexca) == 0) then
+!
+! Mise sur la bonne grille des champs a passer au coupleur
+    call gath2cpl(cpl_sols, wri_sols, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_nsol, wri_nsol, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_rain, wri_rain, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_snow, wri_snow, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_evap, wri_evap, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_tsol, wri_tsol, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_fder, wri_fder, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_albe, wri_albe, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_taux, wri_taux, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_tauy, wri_tauy, klon, knon,iim,jjm, knindex)
+    call gath2cpl(cpl_ruis, wri_ruis, klon, knon,iim,jjm, knindex)
+!
+! Passage des champs au coupleur
+!
+    call intocpl(itime, iim, jjm , wri_sols, wri_nsol, wri_rain, wri_snow, &
+      & wri_evap, wri_tsol, wri_fder, wri_albe, wri_taux, wri_tauy,       &
+      & wri_ruis ) 
+    cpl_sols = 0.
+    cpl_nsol = 0.
+    cpl_rain = 0.
+    cpl_snow = 0.
+    cpl_evap = 0.
+    cpl_tsol = 0.
+    cpl_fder = 0.
+    cpl_albe = 0.
+    cpl_taux = 0.
+    cpl_tauy = 0.
+    cpl_ruis = 0.
+
+    call fromcpl(itime,(jjm+1)*iim,                                          &
+     &        read_sst, read_sic, read_alb_sst, read_alb_sic)
+    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_sic, tamp_sic , klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_alb_sst, alb_new, klon, knon,iim,jjm, knindex)
+    call cpl2gath(read_alb_sic, alb_ice, klon, knon,iim,jjm, knindex)
+! transformer tamp_sic en pctsrf_new
+
+    do ig = 1, klon
+      IF (pctsrf(ig,is_oce) > epsfra .OR.            &
+     &             pctsrf(ig,is_sic) > epsfra) THEN
+            pctsrf_new(ig,is_oce) = pctsrf(ig,is_oce)    &
+     &                        - (tamp_sic(ig)-pctsrf(ig,is_sic))
+            pctsrf_new(ig,is_sic) = tamp_sic(ig)
+      endif
+    enddo
+  endif
+
   END SUBROUTINE interfoce_cpl
 !
 !#########################################################################
 !
+
   SUBROUTINE interfoce_slab(nisurf)
 
@@ -825,9 +1085,10 @@
 !
 
-  SUBROUTINE calcul_fluxs( knon, dtime, &
+  SUBROUTINE calcul_fluxs( knon, nisurf, dtime, &
      & tsurf, p1lay, cal, beta, coef1lay, ps, &
+     & precip_rain, precip_snow, snow, qsol, &
      & radsol, dif_grnd, t1lay, q1lay, u1lay, v1lay, &
      & petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     & tsurf_new, fluxlat, fluxsens, dflux_s, dflux_l)
+     & tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
 
 ! Cette routine calcule les fluxs en h et q a l'interface et eventuellement
@@ -838,4 +1099,5 @@
 ! input:
 !   knon         nombre de points a traiter
+!   nisurf       surface a traiter
 !   tsurf        temperature de surface
 !   p1lay        pression 1er niveau (milieu de couche)
@@ -844,4 +1106,9 @@
 !   coef1lay     coefficient d'echange
 !   ps           pression au sol
+!   precip_rain  precipitations liquides
+!   precip_snow  precipitations solides
+!   snow         champs hauteur de neige
+!   qsol         humidite du sol
+!   runoff       runoff en cas de trop plein
 !   petAcoef     coeff. A de la resolution de la CL pour t
 !   peqAcoef     coeff. A de la resolution de la CL pour q
@@ -862,7 +1129,8 @@
 #include "YOETHF.inc"
 #include "FCTTRE.inc"
+#include 'indicesol.h'
 
 ! Parametres d'entree
-  integer, intent(IN) :: knon
+  integer, intent(IN) :: knon, nisurf
   real   , intent(IN) :: dtime
   real, dimension(knon), intent(IN) :: petAcoef, peqAcoef
@@ -870,9 +1138,11 @@
   real, dimension(knon), intent(IN) :: ps, q1lay
   real, dimension(knon), intent(IN) :: tsurf, p1lay, cal, beta, coef1lay
+  real, dimension(knon), intent(IN) :: precip_rain, precip_snow
   real, dimension(knon), intent(IN) :: radsol, dif_grnd
   real, dimension(knon), intent(IN) :: t1lay, u1lay, v1lay
+  real, dimension(knon), intent(INOUT) :: snow, qsol
 
 ! Parametres sorties
-  real, dimension(knon), intent(OUT):: tsurf_new, fluxlat, fluxsens
+  real, dimension(knon), intent(OUT):: tsurf_new, evap, fluxsens, fluxlat
   real, dimension(knon), intent(OUT):: dflux_s, dflux_l
 
@@ -885,9 +1155,32 @@
   real, dimension(knon) :: zx_h_ts, zx_q_0 , d_ts
   real                  :: zdelta, zcvm5, zx_qs, zcor, zx_dq_s_dh
+  real                  :: bilan_f, fq_fonte
   real, parameter :: t_grnd = 271.35, t_coup = 273.15
   logical         :: check = .true.
   character (len = 20)  :: modname = 'calcul_fluxs'
+  logical         :: fonte_neige = .false.
+  real            :: max_eau_sol = 150.0
+  character (len = 80) :: abort_message 
 
   if (check) write(*,*)'Entree ', modname
+
+  if (size(run_off) /= knon .AND. nisurf == is_ter) then
+    write(*,*)'Bizarre, le nombre de points continentaux'
+    write(*,*)'a change entre deux appels. J''arrete ...'
+    abort_message='Pb run_off'
+    call abort_gcm(modname,abort_message,1)
+  endif
+!
+! Traitement neige et humidite du sol
+!
+    if (nisurf == is_oce) then
+      snow = 0.
+      qsol = max_eau_sol
+    else
+      snow = max(0.0, snow + (precip_snow - evap) * dtime)
+      qsol = qsol + (precip_rain - evap) * dtime
+    endif 
+
+
 ! 
 ! Initialisation
@@ -961,4 +1254,12 @@
      &                       zx_nh(i) + zx_sl(i) * zx_nq(i)) &  
      &                     + dtime * dif_grnd(i))
+
+!
+! Y'a-t-il fonte de neige?
+!
+    fonte_neige = (nisurf /= is_oce) .AND. &
+     & (snow(i) > 0. .OR. nisurf == is_sic .OR. nisurf == is_lic) &
+     & .AND. (tsurf_new(i) >= RTT)
+    if (fonte_neige) tsurf_new(i) = RTT  
     zx_h_ts(i) = tsurf_new(i) * RCPD * zx_pkh(i)
     d_ts(i) = tsurf_new(i) - tsurf(i)
@@ -966,9 +1267,25 @@
 !== flux_q est le flux de vapeur d'eau: kg/(m**2 s)  positive vers bas
 !== flux_t est le flux de cpt (energie sensible): j/(m**2 s)
-    fluxlat(i) = zx_mq(i) + zx_nq(i) * tsurf_new(i) 
+    evap(i) = - zx_mq(i) - zx_nq(i) * tsurf_new(i) 
+    fluxlat(i) = - evap(i) * zx_sl(i)
     fluxsens(i) = zx_mh(i) + zx_nh(i) * tsurf_new(i)
 ! Derives des flux dF/dTs (W m-2 K-1):
     dflux_s(i) = zx_nh(i)
     dflux_l(i) = (zx_sl(i) * zx_nq(i))
+!
+! en cas de fonte de neige
+!
+    if (fonte_neige) then
+      bilan_f = radsol(i) + fluxsens(i) - (zx_sl(i) * evap (i)) - &
+     &          dif_grnd(i) * (tsurf_new(i) - t_grnd) - &
+     &          RCPD * (zx_pkh(i))/cal(i)/dtime * (tsurf_new(i) - tsurf(i))
+      bilan_f = max(0., bilan_f)
+      fq_fonte = bilan_f / zx_sl(i)
+      snow(i) = max(0., snow(i) - fq_fonte * dtime)
+      qsol(i) = qsol(i) + (fq_fonte * dtime)
+    endif
+    if (nisurf == is_ter)  &
+     &  run_off(i) = run_off(i) + max(qsol(i) - max_eau_sol, 0.0)
+    qsol(i) = min(qsol(i), max_eau_sol) 
   ENDDO
 
@@ -978,3 +1295,201 @@
 !
 
+  SUBROUTINE sol_dem_write(itime, klon, rlon, rlat, &
+  &                     pctsrf_new,tsurf_new,alb_new)
+
+! Routine d'ecriture de l'etat de redemarrage pour le sol
+!
+! L.Fairhead
+!
+! input:
+!   itime        numero du pas de temps
+!   klon         nombre total de points de grille
+!   rlon         longitudes
+!   rlat         latitudes
+!   tsurf_new    temperature au sol
+!   alb_new      albedo
+!   pctsrf_new   repartition des surfaces
+
+  include 'indicesol.h'
+#include 'temps.inc'
+  include 'netcdf.inc'
+
+! Parametres d'entree
+  integer, intent(IN) :: itime
+  integer, intent(IN) :: klon
+  real, dimension(klon), intent(IN) :: rlon, rlat
+  real, dimension(klon,nbsrf), intent(IN)  :: tsurf_new, alb_new
+  real, dimension(klon,nbsrf), intent(IN) :: pctsrf_new
+
+! Variables locales
+  integer             :: ierr, nid
+  integer             :: idim1, idim2, idim3
+  integer,parameter   :: length = 100
+  character (len = 20) :: modname = 'sol_dem_write'
+  character (len = 80) :: abort_message 
+  real, dimension(length) :: tab_cntrl = 0.
+  integer                 :: nvarid
+
+  ierr = NF_CREATE('restartsol', NF_CLOBBER, nid)
+  IF (ierr.NE.NF_NOERR) THEN
+    abort_message=' Pb d''ouverture du fichier restartsol'
+    CALL abort_gcm(modname,abort_message,ierr)
+  ENDIF
+
+  ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 23,    &
+     &                    "Fichier redemmarage sol")
+  ierr = NF_DEF_DIM (nid, "index", length, idim1)
+  ierr = NF_DEF_DIM (nid, "points_physiques", klon, idim2)
+  ierr = NF_DEF_DIM (nid, "nombre_surfaces", nbsrf, idim3)
+  ierr = NF_ENDDEF(nid)
+
+  tab_cntrl(13) = day_end
+  tab_cntrl(14) = anne_ini
+
+  ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+  ierr = NF_DEF_VAR (nid, "controle", NF_DOUBLE, 1, idim1,nvarid)
+#else
+  ierr = NF_DEF_VAR (nid, "controle", NF_FLOAT, 1, idim1,nvarid)
+#endif
+  ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 22,  &
+     &                        "Parametres de controle")
+  ierr = NF_ENDDEF(nid)
+#ifdef NC_DOUBLE
+  ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
+#else
+  ierr = NF_PUT_VAR_REAL (nid,nvarid,tab_cntrl)
+#endif
+
+  ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+  ierr = NF_DEF_VAR (nid, "longitude", NF_DOUBLE, 1, idim2,nvarid)
+#else
+  ierr = NF_DEF_VAR (nid, "longitude", NF_FLOAT, 1, idim2,nvarid)
+#endif
+  ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 32,  &
+     &               "Longitudes de la grille physique")
+  ierr = NF_ENDDEF(nid)
+#ifdef NC_DOUBLE
+  ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlon)
+#else
+  ierr = NF_PUT_VAR_REAL (nid,nvarid,rlon)
+#endif
+!
+  ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+  ierr = NF_DEF_VAR (nid, "latitude", NF_DOUBLE, 1, idim2,nvarid)
+#else
+  ierr = NF_DEF_VAR (nid, "latitude", NF_FLOAT, 1, idim2,nvarid)
+#endif
+  ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 31,    &
+     &                        "Latitudes de la grille physique")
+  ierr = NF_ENDDEF(nid)
+#ifdef NC_DOUBLE
+  ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlat)
+#else
+  ierr = NF_PUT_VAR_REAL (nid,nvarid,rlat)
+#endif
+        ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+        ierr = NF_DEF_VAR (nid, "TS", NF_DOUBLE, 1, idim2,nvarid)
+#else
+        ierr = NF_DEF_VAR (nid, "TS", NF_FLOAT, 1, idim2,nvarid)
+#endif
+        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 22, &
+     &                        "Temperature de surface")
+        ierr = NF_ENDDEF(nid)
+
+
+
+
+  END SUBROUTINE sol_dem_write
+!
+!#########################################################################
+!
+  SUBROUTINE gath2cpl(champ_in, champ_out, klon, knon, iim, jjm, knindex)
+
+! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
+! au coupleur.
+!
+! 
+! input:         
+!   champ_in     champ sur la grille gathere        
+!   knon         nombre de points dans le domaine a traiter
+!   knindex      index des points de la surface a traiter
+!   klon         taille de la grille
+!   iim,jjm      dimension de la grille 2D
+!
+! output:
+!   champ_out    champ sur la grille 2D
+!
+! input
+  integer                   :: klon, knon, iim, jjm
+  real, dimension(knon)     :: champ_in
+  integer, dimension(knon)  :: knindex
+! output
+  real, dimension(iim,jjm+1)  :: champ_out
+! local
+  integer                   :: i, ig, j
+  real, dimension(klon)     :: tamp
+
+  do i = 1, knon
+    ig = knindex(i)
+    tamp(ig) = champ_in(i)
+  enddo    
+  champ_out(:,1) = tamp(1)
+  do j = 2, jjm
+    do i = 1, iim
+      champ_out(i,j) = tamp((j-2)*jjm + i + 1)
+    enddo
+  enddo
+  champ_out(:,jjm+1) = tamp(klon)
+
+  END SUBROUTINE gath2cpl
+!
+!#########################################################################
+!
+  SUBROUTINE cpl2gath(champ_in, champ_out, klon, knon, iim, jjm, knindex)
+
+! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
+! au coupleur.
+!
+! 
+! input:         
+!   champ_in     champ sur la grille gathere        
+!   knon         nombre de points dans le domaine a traiter
+!   knindex      index des points de la surface a traiter
+!   klon         taille de la grille
+!   iim,jjm      dimension de la grille 2D
+!
+! output:
+!   champ_out    champ sur la grille 2D
+!
+! input
+  integer                   :: klon, knon, iim, jjm
+  real, dimension(iim,jjm+1)     :: champ_in
+  integer, dimension(knon)  :: knindex
+! output
+  real, dimension(knon)  :: champ_out
+! local
+  integer                   :: i, ig, j
+  real, dimension(klon)     :: tamp
+
+  tamp(1) = champ_in(1,1)
+  do j = 2, jjm
+    do i = 1, iim
+      tamp((j-2)*jjm + i + 1) = champ_in(i,j)
+    enddo
+  enddo
+  tamp(klon) = champ_in(1,jjm+1)
+
+  do i = 1, knon
+    ig = knindex(i)
+    champ_out(i) = tamp(ig)
+  enddo    
+
+  END SUBROUTINE cpl2gath
+!
+!#########################################################################
+!
   END MODULE interface_surf
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.F
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.F	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.F	(revision 98)
@@ -386,5 +386,5 @@
       END
 
-      SUBROUTINE fromcpl(kt, imjm, sst, gla)
+      SUBROUTINE fromcpl(kt, imjm, sst,sic, alb_sst, alb_sic )
       IMPLICIT none
 c
@@ -399,5 +399,8 @@
       INTEGER imjm, kt
       REAL sst(imjm)          ! sea-surface-temperature
-      REAL gla(imjm)          ! sea-ice
+      REAL alb_sst(imjm)  ! open sea albedo
+      REAL sic(imjm)      ! sea ice cover
+      REAL alb_sic(imjm)  ! sea ice albedo
+
 c
       INTEGER nuout             ! listing output unit
@@ -447,5 +450,11 @@
      $          nuout)
             IF (jf.eq.2)
-     $          CALL locread(cl_read(jf), gla, imjm, nuread, iflag,
+     $          CALL locread(cl_read(jf), sic, imjm, nuread, iflag,
+     $          nuout)
+            IF (jf.eq.3)
+     $          CALL locread(cl_read(jf), alb_sst, imjm, nuread, iflag,
+     $          nuout)
+            IF (jf.eq.4)
+     $          CALL locread(cl_read(jf), alb_sic, imjm, nuread, iflag,
      $          nuout)
             CLOSE (nuread)
@@ -474,5 +483,15 @@
 c
           CALL SIPC_Read_Model(index, imjm, cmodinf, 
-     $              cljobnam_r,infos, gla)
+     $              cljobnam_r,infos, sic)
+c         Index of open sea albedo in total number of fields jpfldo2a: 
+          index = 3
+c
+          CALL SIPC_Read_Model(index, imjm, cmodinf, 
+     $              cljobnam_r,infos, alb_sst)
+c         Index of sea-ice albedo in total number of fields jpfldo2a: 
+          index = 4
+c
+          CALL SIPC_Read_Model(index, imjm, cmodinf, 
+     $              cljobnam_r,infos, alb_sic)
 c
 c
@@ -482,8 +501,10 @@
 c exchanges from ocean=CPL to atmosphere
 c
-          DO jf=1,jpfldo2a
-            IF (jf.eq.1) CALL CLIM_Import (cl_read(jf) , kt, sst, info)
-            IF (jf.eq.2) CALL CLIM_Import (cl_read(jf) , kt, gla, info)
-            IF ( info .NE. CLIM_Ok) THEN
+        DO jf=1,jpfldo2a
+          IF (jf.eq.1) CALL CLIM_Import (cl_read(jf) , kt, sst, info)
+          IF (jf.eq.2) CALL CLIM_Import (cl_read(jf) , kt, sic, info)
+         IF (jf.eq.3) CALL CLIM_Import (cl_read(jf) , kt, alb_sst, info)
+         IF (jf.eq.4) CALL CLIM_Import (cl_read(jf) , kt, alb_sic, info)
+          IF ( info .NE. CLIM_Ok) THEN
                 WRITE(nuout,*)'Pb in reading ', cl_read(jf), jf
                 WRITE(nuout,*)'Couplage kt is = ',kt
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.h
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.h	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/oasis.h	(revision 98)
@@ -1,9 +1,14 @@
-      LOGICAL ok_oasis
-      PARAMETER (ok_oasis = .FALSE.)
-c
-      CHARACTER*4 cchan
-      PARAMETER (cchan="PIPE")
-c      PARAMETER (cchan="CLIM")
+C
+C -- oasis.h   
+C    ******
+C@
+C@  Contents : choice for the OASIS version: clim or pipe
+C@  --------
 
-      INTEGER jpmaxfld
-      PARAMETER(jpmaxfld = 20)
+      logical ok_oasis
+      parameter(ok_oasis = .false.)
+
+      CHARACTER*8 cchan
+      PARAMETER ( cchan='PIPE' )
+C
+C     --- end of oasis.h
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_cou.h
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_cou.h	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_cou.h	(revision 98)
@@ -2,10 +2,13 @@
 C -- param_cou.h
 C
+	INTEGER jpmaxfld
+	PARAMETER(jpmaxfld = 100)        ! Number of maximum fields
+                                         ! exchange betwwen ocean and atmosphere
 	INTEGER jpflda2o
-	PARAMETER(jpflda2o = 1)          ! Number of fields exchanged from
+	PARAMETER(jpflda2o = 8)          ! Number of fields exchanged from
                                          ! atmosphere to ocean
 C
 	INTEGER jpfldo2a
-	PARAMETER(jpfldo2a = 1)          ! Number of fields exchanged from
+	PARAMETER(jpfldo2a = 2)          ! Number of fields exchanged from
                                          ! ocean to atmosphere
 C
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_sipc.h
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_sipc.h	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/param_sipc.h	(revision 98)
@@ -10,5 +10,5 @@
 	INTEGER jpbyteint,jpbyterea, jpbytecha  
         PARAMETER (jpbyteint = 4)
-	PARAMETER (jpbyterea = 4)
+	PARAMETER (jpbyterea = 8)
 	PARAMETER (jpbytecha = 1)
 C@
